#ifndef RALEIGH_W_LABEL_H
#define RALEIGH_W_LABEL_H

#include <raleigh/widget.h>
#include <libfont/fonts.h>

namespace raleigh {
  class label : public widget {
  public:
    //value's data is copied
    label(const char *value, const char *font="fixed-10", bool bg_transparent=true,
      _pixel_t fg=RGB(00, 00, 00), _pixel_t bg=RGB(bf, bf, bf));

    void change_value(const char *new_value);

    void paint(_pixel_t *pixbuf, uint32_t pitch) override;
    void notify_has_opaque_parent(widget *parent) override;
  private:
    char *value;
    uint32_t v_size;
    const struct font_info *const fi;
    bool bg_transparent;
    const _pixel_t fg;
    const _pixel_t bg;
  };
}

#endif